# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `mip` Chapter.
"""

# NAG Copyright 2017-2024.

from ..base import utils

handle_solve_milp_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_C_PTR, # Input, handle.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, inform.
)
handle_solve_milp = utils._EngineState._get_symbol('h02bkf')
handle_solve_milp.restype = None
handle_solve_milp.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[100].
    handle_solve_milp_monit,
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, ifail.
)

milp_dummy_monit = utils._EngineState._get_symbol('h02bku')
milp_dummy_monit.restype = None
milp_dummy_monit.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, inform.
)
