# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `opt` Chapter.
"""

# NAG Copyright 2017-2024.

from ..base import utils

handle_solve_lp_simplex_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_C_PTR, # Input, handle.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, inform.
)
handle_solve_lp_simplex = utils._EngineState._get_symbol('e04mkf')
handle_solve_lp_simplex.restype = None
handle_solve_lp_simplex.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar].
    utils._BYREF_INT, # Input, nnzu.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, u[nnzu].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[100].
    handle_solve_lp_simplex_monit,
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, ifail.
)

lp_simplex_dummy_monit = utils._EngineState._get_symbol('e04mku')
lp_simplex_dummy_monit.restype = None
lp_simplex_dummy_monit.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, inform.
)
